
  utils.importFile("src/CcasereadVersion.js");
  /* Copy Module */
  var copy = xdc.loadCapsule('ti/mas/swtools/Copy.xs');

   environment["xdc.hostOS"] = java.lang.System.getProperty("os.name") + "";
    if (environment["xdc.hostOS"].match(/^Windows/i)) {
        environment["xdc.hostOS"] = "Windows";
    }
  
 /* Read the Package Name */
  
  var xmlTree= xdc.loadXML("./package/package.bld.xml");
  if(xmlTree == undefined)
  { 
     print("Could not load the XML file, Please rebuild the package and try"); 
     java.lang.System.exit(1);
  }
  else
  {
    var argsName= xmlTree.@name;  
  }

/* Get the Version */
var warningBuffer = new Array();
var value=readVersion(argsName);
var moduleName=argsName.split(".");
var packageName=moduleName[moduleName.length-1];
value=value.toString().replace(/\s/g, "");
value2=value.toString().replace(/\,/g, ".");
value1=value.toString().replace(/\./g, "_");
var srcFile = "docs/doxygen/tmp/index.html"; 
var modFile = "docs/doxygen/tmp/"+packageName+"_"+value1+returnQualityString(argsName)+"_release_notes.html";
var dstFile = packageName+"_"+value1+returnQualityString(argsName)+"_release_notes.html";
var matchstring = packageName+"_"+value1;
var fileExists = xdc.findFile("./"+dstFile);
var date=new java.util.Date();
var months = new Array('January','February','March', 'April','May','June','July','August','September', 'October','November','December');
var dateLine = "<h2 align='center'>"+ months[date.getMonth()]+" "+ date.getDate()+", "+(date.getYear()+1900)+"<\/h2>";

    /* copy the environment array from the current environment */
    var env   = java.lang.System.getenv();
    var keys  = env.keySet().toArray();
    var key;
    var stat={};
    var env_j=[];
    for (var i = 0; i < keys.length; i++) {
         key = keys[i];
      if (env.get(key) == "") {
             continue;
         }
         env_j = env_j.concat([key + '=' + env.get(key)]);
     }
   var attrs = {
        envs: env_j
   }
 
  var command;

var fileModule = xdc.module('xdc.services.io.File');
var openedFile;
try{
   openedFile = fileModule.open(srcFile, "r");
 } catch (ex)
 {
   print(srcFile + " cannot be read");
 }

var writeFile;
try{
   writeFile = fileModule.open(modFile, "w");
 } catch (ex)
 {
   print(modFile + " cannot be written to. Please check Writing Permissions.");
 }

 var readLine;
 while((readLine=openedFile.readLine()) != null)
 {
   if(readLine.match("Main Page"))
   {
      readLine=readLine.replace(/Main Page/,packageName.toString().toUpperCase()+" "+ value2+returnQualityString(argsName).replace("_"," ")+" Release Notes");
   } 
   if(readLine.match("<!-- Generated by Doxygen"))
   {
         writeFile.writeLine(readLine);
         readLine = "<h1 align='center'><a name='XDC_TOP'><\/a>"+ packageName.toString().toUpperCase()+" "+ value2+returnQualityString(argsName).replace("_"," ")+" Release Notes"+"<\/h1>";
         writeFile.writeLine(readLine);
         readLine=""+dateLine;
    } 
   if(readLine.match("tilogo.gif"))
   {
      readLine=readLine.replace(/tilogo.gif/,"docs/relnotes_archive/tilogo.gif");
   }
  if(readLine.match("titagline.gif"))
   {
      readLine=readLine.replace(/titagline.gif/,"docs/relnotes_archive/titagline.gif");
   }
   writeFile.writeLine(readLine);
 }
 
     var relDir = new java.io.File("./docs/relnotes_archive");
     if(!(relDir.exists() && relDir.isDirectory()))
     {

   
      print("Creating relnotes_archive Directory.....");      
      relDir.mkdirs();     
      
      /* Copy titagline.gif */
      copy.File("docs/doxygen/tmp/titagline.gif","docs/relnotes_archive");

      /* Copy tilogo.gif */
      copy.File("docs/doxygen/tmp/tilogo.gif","docs/relnotes_archive");      

/* GIT  */
     
      print("Checking out docs directory"); 
   
      
      print("Creating "+packageName+" Directory.....");      
      var targetDir = new java.io.File("../docs/"+packageName);
      if(!(targetDir.exists() && targetDir.isDirectory()))
      {
       targetDir.mkdirs();
      } 

      print("Creating "+packageName+"/docs Directory.....");      
      var targetDir = new java.io.File("../docs/"+packageName+"/docs");
      if(!(targetDir.exists() && targetDir.isDirectory()))
      {
       targetDir.mkdirs();
      }
      
      print("Creating "+packageName+"/docs/relnotes_archive Directory.....");      
      var targetDir = new java.io.File("../docs/"+packageName+"/docs/relnotes_archive");
      if(!(targetDir.exists() && targetDir.isDirectory()))
      {
       targetDir.mkdirs();
      }  


      
      
      /* Copy titagline.gif */
      copy.File("docs/doxygen/tmp/titagline.gif","../docs/"+packageName+"/docs/relnotes_archive");

      /* Copy tilogo.gif */
      copy.File("docs/doxygen/tmp/tilogo.gif","../docs/"+packageName+"/docs/relnotes_archive");      

      command="git.exe add ../docs/"+packageName+"/docs/relnotes_archive";
      xdc.exec(command,attrs,stat);
      if( (stat.output).match("fatal:") )
      {
          
             print(stat.output);
             java.lang.System.exit(1);
          
      }       
      
      
/* END GIT */

      
      
   }
/* Check if file differs only in quality */
if(!fileExists)
{
   var file = new java.io.File(".");
   var list = file.list();
   var i, j;
   for (i = 0, j = 0; i < list.length; i++) {
     if (list[i].match("_release_notes.html") != null && list[i].match("_release_notes.html.") == null) {
     
      if(list[i].match(matchstring)|| list[i].match("beta") || list[i].match("alpha") || list[i].match("prealpha"))
      {
      copy.Move(list[i],dstFile);
	  java.io.File(list[i])["delete"]();

/* GIT */
      command="git.exe mv -f ../docs/"+packageName+"/"+list[i]+" ../docs/"+packageName+"/"+ dstFile;   
      print(command);
      xdc.exec(command,attrs,stat);
      if( (stat.output).match("fatal:") )
      {
         print(stat.output);
         java.lang.System.exit(1);
         
      }         



/* CLARCASE END */      
             
      fileExists=true; 
      
      }
     }
    }
      
 }
   

if(!fileExists)
{
  /* Move old Release notes under release_archive
     1) Check if there is relnotes_archive under docs directory.
     2) If not create relnotes_archive directory and add it to source control.
     3) Move the old release notes under relnotes_archive directory
  */
     
 
   var file = new java.io.File(".");
   var list = file.list();
   var i, j;
   for (i = 0, j = 0; i < list.length; i++) {
     if (list[i].match("_release_notes.html") != null && list[i].match("_release_notes.html.") == null) {
   /* GIT */
      command="git.exe  mv -f ..//docs//"+packageName+"//"+list[i]+" ..//docs//"+packageName+"//docs//relnotes_archive//"+list[i];
      xdc.exec(command,attrs,stat);
      if( (stat.output).match("fatal:") )
      {
         print(stat.output);
         java.lang.System.exit(1);
      } 
     

/* GIT End */     
     
      copy.File(list[i], "docs/relnotes_archive");
      
      java.io.File(list[i])['delete']();
      
      /* Modify the old release notes for the relative address */
      var oldReleaseFile = "docs/relnotes_archive/"+list[i];
    var openedFile;
    try{
       openedFile = fileModule.open(oldReleaseFile, "r");
    } catch (ex)
    {
        print(srcFile + " cannot be read");
     }

    var writeFile;
    try{
        writeFile = fileModule.open("docs/relnotes_archive/temp.html", "w");
    } catch (ex)
    {
        print(modFile + " cannot be written to. Please check Writing Permissions.");
    }

   var readLine
   while((readLine=openedFile.readLine()) != null)
   {
      if(readLine.match("\='docs\/"))
      {
         readLine=readLine.replace(/docs/,"..");
         
      } 
      writeFile.writeLine(readLine);
    }
    
   copy.Move("docs/relnotes_archive/temp.html",oldReleaseFile);

   java.io.File("docs/relnotes_archive/temp.html")['delete']();
  }
 }
 
  /*Copy New Release notes */
  copy.File(modFile,".");
  
 /*Copy New Release notes */
  copy.File(modFile,"../docs/"+packageName);
  
   /* Add the release notes to the source control */
  command="git.exe add  ../docs/"+packageName+"/"+dstFile;
  xdc.exec(command,attrs,stat);
  if( (stat.output).match("fatal:") )
  {
    
       print(stat.output);
       java.lang.System.exit(1);
    
  }   
 
 
}
else
{
  /* Compare New and Old release notes */
  if(compare_relNote(dstFile,modFile) > 0)
  {
    /* file exists replace the current file */
  print(dstFile+" Exists"); 
   /* copy */
   copy.File(modFile,".");
  
   copy.File(modFile,"../docs/"+packageName);

  print("Release notes generation completed ...");
  }
  else
  {
    print("New and old release notes match. Keeping old releasenotes..");
  }
  
}
function compare_relNote(file1,file2)
{
var fileModule = xdc.module('xdc.services.io.File');
var compareFile1;
try{
   compareFile1 = fileModule.open(file1, "r");
 } catch (ex)
 {
   print(file1 + " cannot be read");
 }
 
var compareFile2;
try{
   compareFile2 = fileModule.open(file2, "r");
 } catch (ex)
 {
   print(file2 + " cannot be written to. Please check Writing Permissions.");
 }
 
 var readLine1;
 var readLine2;
 var match=0;
 var total=0;
 var nomatch=0;
 while((readLine2=compareFile2.readLine()) != null)
 {
   readLine1=compareFile1.readLine();
   total+=1;
   if(readLine1 != readLine2)
   {
      /* date match */
	  
	  if(readLine2 == dateLine)
	   continue;
	   
	  if(readLine1 != null)
      { 	  
	     if(readLine1.match("copyright") && readLine2.match("copyright"))
	     continue;
	  }
	  nomatch+=1;
   } 
   else
   {
      match+=1;
   }
 }
 return nomatch;
}















